// Generated by CoffeeScript 1.6.3
var compilers, fs, log;

fs = require('fs');

compilers = require('./compilers');

log = require('./utils').log;

module.exports = function(opts, cb) {
  var directoryFilter, fileFilter, timeout, walk, watch, watchFile, watching, wss, _ref, _ref1;
  wss = require('./websocket')(opts.server);
  directoryFilter = (_ref = opts.directoryFilter) != null ? _ref : ['!node_modules', '!.git'];
  fileFilter = (_ref1 = opts.fileFilter) != null ? _ref1 : ['!package.json', '!.*', '!npm-debug.log', '!Cakefile', '!README.md'];
  watching = {};
  walk = function(dir, callback) {
    var stream;
    stream = require('readdirp')({
      root: dir,
      directoryFilter: directoryFilter,
      fileFilter: fileFilter
    });
    return stream.on('data', function(file) {
      return callback(file.fullPath);
    });
  };
  watchFile = function(filename, callback) {
    if (watching[filename]) {
      watching[filename].close();
    }
    return fs.exists(filename, function(exists) {
      var err;
      if (!exists) {
        return;
      }
      try {
        return watching[filename] = fs.watch(filename, function() {
          callback(filename);
          return watchFile(filename, callback);
        });
      } catch (_error) {
        err = _error;
        return console.error(err);
      }
    });
  };
  watch = function(dir, callback) {
    return walk(dir, function(filename) {
      if (compilers.compile(filename)) {
        log("  compiling\x1B[0m " + ('.' + filename.substr(dir.length)));
        compilers.compile(filename);
      }
      return watchFile(filename, callback);
    });
  };
  timeout = (new Date()).getTime();
  return watch(opts.dir, function(filename) {
    var now;
    now = (new Date()).getTime();
    if (!((now - timeout) > 100)) {
      return;
    }
    timeout = now;
    log("  modified\x1B[0m " + ('.' + filename.substr(dir.length)));
    if (compilers.compile(filename)) {
      log("  compiling\x1B[0m " + ('.' + filename.substr(dir.length)));
      return;
    }
    wss.send({
      type: 'modified',
      filename: filename
    });
    return log("  reloading");
  });
};

/*
//@ sourceMappingURL=watch.map
*/
